#include <stdio.h>
#include <inttypes.h>
#include <stdlib.h>


int64_t gcd(int64_t a, int64_t b)
{
    int64_t tmp;
    while (a != 0)
    {
        tmp = a;
        a = b % a;
        b = tmp;
    }
    return b;
}


struct rat_num
{
    int64_t up;
    int64_t down;
    double val;  
};


void rat_num_init(struct rat_num * const rn, const int64_t up, const int64_t down)
{
    rn->up = up;
    rn->down = down;
    rn->val = (double)up / down;
}


int compare_rat_nums(const void * _a, const void * _b)
{
    const double a = ((const struct rat_num *)_a)->val;
    const double b = ((const struct rat_num *)_b)->val;

    return (a > b) - (a < b);
}


int main(void)
{
    size_t n, q;
    scanf("%zu %zu", &n, &q);
    struct rat_num nums[n*n];
    int64_t A[n];
    for (int64_t * el = A; el < A + n; ++el)
    {
        scanf("%" SCNd64, el);
    }
    int64_t i = 0, b;
    for  (int64_t _ = 0; _ < n; ++_)
    {
        scanf("%" SCNd64, &b);
        for (int64_t * a = A; a < A + n; ++a, ++i)
        {
            rat_num_init(&nums[i], *a, b);
        }
    }
    qsort(nums, n*n, sizeof(struct rat_num), compare_rat_nums);

    int64_t now_q, _gcd;
    for (int64_t _ = 0; _ < q; ++_)
    {
        scanf("%" SCNd64, &now_q);
        --now_q;
        _gcd = gcd(nums[now_q].up, nums[now_q].down);
        printf("%" PRId64 " %" PRId64 "\n", nums[now_q].up / _gcd, nums[now_q].down / _gcd);
    }
}